"""this middleware akes the user from a request and places it into a
threadlocal, so it can be retrieved in other contests

Stolen from a mail to django usergroup by Luke Plant - 17.6.2006
"""
from threading import local
from django.contrib.auth.models import AnonymousUser

_thread_locals = local()
_anonymous = AnonymousUser()

def get_current_user():
    user = getattr(_thread_locals, 'user',  None)
    if user:
        return user
    else:
        return _anonymous

def get_request():
    request = getattr(_thread_locals, 'request', None)
    return request

class ThreadLocals(object):
    """Middleware that gets various objects from the
    request object and saves them in thread local storage."""
    def process_request(self, request):
        _thread_locals.request = request
        _thread_locals.user = getattr(request, 'user', None)

